<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Low-level primitive textures</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-primitive-textures.html" title="Primitive Textures">
<link rel="prev" href="cogl-primitive-textures.html" title="Primitive Textures">
<link rel="next" href="cogl-2.0-experimental-2D-textures.html" title="2D textures">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-primitive-textures.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-primitive-textures.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-2D-textures.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-Low-level-primitive-textures.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-Low-level-primitive-textures.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-Low-level-primitive-textures"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-Low-level-primitive-textures.top_of_page"></a>Low-level primitive textures</span></h2>
<p>Low-level primitive textures — Interface for low-level textures like
                    <a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a> and <a class="link" href="cogl-2.0-experimental-3D-textures.html#CoglTexture3D" title="CoglTexture3D"><span class="type">CoglTexture3D</span></a>.</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-Low-level-primitive-textures.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#CoglPrimitiveTexture" title="CoglPrimitiveTexture">CoglPrimitiveTexture</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#cogl-is-primitive-texture" title="cogl_is_primitive_texture ()">cogl_is_primitive_texture</a>           (<em class="parameter"><code><span class="type">void</span> *object</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#cogl-primitive-texture-set-auto-mipmap" title="cogl_primitive_texture_set_auto_mipmap ()">cogl_primitive_texture_set_auto_mipmap</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#CoglPrimitiveTexture" title="CoglPrimitiveTexture"><span class="type">CoglPrimitiveTexture</span></a> *primitive_texture</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> value</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Low-level-primitive-textures.description"></a><h2>Description</h2>
<p>
A <a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#CoglPrimitiveTexture" title="CoglPrimitiveTexture"><span class="type">CoglPrimitiveTexture</span></a> is a texture that is directly represented
by a single texture on the GPU. For example these could be a
<a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a>, <a class="link" href="cogl-2.0-experimental-3D-textures.html#CoglTexture3D" title="CoglTexture3D"><span class="type">CoglTexture3D</span></a> or <a class="link" href="cogl-2.0-experimental-Rectangle-textures-(non-normalized-coordinates).html#CoglTextureRectangle" title="CoglTextureRectangle"><span class="type">CoglTextureRectangle</span></a>. This is
opposed to high level meta textures which may be composed of
multiple primitive textures or a sub-region of another texture such
as <span class="type">CoglAtlasTexture</span> and <a class="link" href="cogl-2.0-experimental-Sliced-Textures.html#CoglTexture2DSliced" title="CoglTexture2DSliced"><span class="type">CoglTexture2DSliced</span></a>.
</p>
<p>
A texture that implements this interface can be directly used with
the low level <a class="link" href="cogl-2.0-experimental-Primitives.html#cogl-primitive-draw" title="cogl_primitive_draw ()"><code class="function">cogl_primitive_draw()</code></a> API. Other types of textures
need to be first resolved to primitive textures using the
<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> interface.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Most developers won't need to use this interface directly but
still it is worth understanding the distinction between high-level
and primitive textures because you may find other references in the
documentation that detail limitations of using
primitive textures.</div>
<p>
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Low-level-primitive-textures.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglPrimitiveTexture"></a><h3>CoglPrimitiveTexture</h3>
<pre class="programlisting">typedef struct _CoglPrimitiveTexture CoglPrimitiveTexture;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-primitive-texture"></a><h3>cogl_is_primitive_texture ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_primitive_texture           (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Gets whether the given object references a primitive texture object.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> pointer</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the pointer references a primitive texture, and
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-primitive-texture-set-auto-mipmap"></a><h3>cogl_primitive_texture_set_auto_mipmap ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_primitive_texture_set_auto_mipmap
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#CoglPrimitiveTexture" title="CoglPrimitiveTexture"><span class="type">CoglPrimitiveTexture</span></a> *primitive_texture</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> value</code></em>);</pre>
<p>
Sets whether the texture will automatically update the smaller
mipmap levels after any part of level 0 is updated. The update will
only occur whenever the texture is used for drawing with a texture
filter that requires the lower mipmap levels. An application should
disable this if it wants to upload its own data for the other
levels. By default auto mipmapping is enabled.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>primitive_texture</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Low-level-primitive-textures.html#CoglPrimitiveTexture" title="CoglPrimitiveTexture"><span class="type">CoglPrimitiveTexture</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>value</code></em> :</span></p></td>
<td>The new value for whether to auto mipmap</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>